#ifndef MiniGame_H
#define MiniGame_H

#include <Bild.h>
#include <Text.h>
#include <AlphaFeld.h>

using namespace Framework;

class MiniGame
{
private:
    double xPos;
    double yPos;
    int xAbs;
    int yAbs;
    int zXPos;
    int zYPos;
    double xSpeed;
    double ySpeed;
    Text *name;
    Bild *bgBild;
    AlphaFeld *mausAlpha;
    LRahmen *rahmen;
    bool sichtbar;
    unsigned char alpha;
    bool mausIn;
    bool ok;
    bool rend;
    int ref;

public:
    // Konstruktor
    MiniGame( char *name );
    // Destruktor
    ~MiniGame();
    // nicht constant
    void setPosition( int x, int y );
    void setSichtbar( bool sichtbar );
    void doMausEreignis( MausEreignis &me );
    bool tick( double z );
    void render( Bild &zRObj );
    // constant
    Text *zName();
    bool istOk() const;
    // Reference Counting
    MiniGame *getThis();
    MiniGame *release();
};

#endif